from pysparse import spmatrix, precon, itsolvers
from pylab import *
from laplace1d import timesT
import numpy

class Laplace1d:
    """Class defining multiplication by a 1D Laplacian
    """
    def __init__(self,n):
        self.shape = (n,n)

    def matvec(self, x, y):
        timesT(y, x)

n = 100
b = numpy.ones(n)
x = numpy.empty(n)
L = Laplace1d(n)
info, iter, relres = itsolvers.pcg(L, b, x, 1e-12, 2000)

plot(x)
savefig("demo.pdf")
