%module laplace1d
%{
#define SWIG_FILE_WITH_INIT
extern void timesT(int n, double* Ax, double* x);
%}

%include "numpy.i"

%init %{
import_array();
%}

%apply (int DIM1, double* INPLACE_ARRAY1) {(int len1, double* vec1)}
%apply (int DIM1, double* IN_ARRAY1)      {(int len2, double* vec2)}

%rename (timesT) my_timesT;
%inline %{
void my_timesT(int len1, double* vec1, int len2, double* vec2)
{
    if (len1 != len2) {
        PyErr_Format(PyExc_ValueError,
                     "Arrays of lengths (%d,%d) given",
                     len1, len2);
    }
    timesT(len1, vec1, vec2);
}
%}
