#! /usr/bin/env python

# System imports
from distutils.core import *
from distutils      import sysconfig

# Third-party modules - we depend on numpy for everything
import numpy

# Obtain the numpy include directory.  This logic works across numpy versions.
try:
    numpy_include = numpy.get_include()
except AttributeError:
    numpy_include = numpy.get_numpy_include()

# laplace1d extension module
_laplace1d = Extension( "_laplace1d",
                      ["laplace1d.i","laplace1d.c"],
                      include_dirs = [numpy_include]
                    )

# setup
setup(  name        = "timesT function",
        description = "timesT applies 1D Laplacian to a vector",
        author      = "David Bindel",
        version     = "1.0",
        ext_modules = [_laplace1d] 
     )

